<?
/*
*******************************
 IP-SYMCON Event Scripting
*******************************
File     : Collect.ips.php
Trigger  : 
Interval : 
Author   : HJH
Project  : Installation
Date     : 03.01.07
*/



$project = "Farbverlauf"; // hier den Projektnamen (Name des Ordners) eintragen



// Projektverzeichnis anlegen, falls nicht vorhanden ***************************
$basePath = IPS_GetKernelDir();
$scriptPath = $basePath. "scripts\\";
$projectPath = $scriptPath. $project. "\\";
if (!file_exists($projectPath))
{
 if (mkdir($projectPath))
 {
  echo "Projektverzeichnis wurde angelegt: \"". $projectPath. "\"\r\n";
 }
 else
 {
  echo "Projektverzeichnis konnte nicht erstellt werden: \"". $projectPath. "\"\r\n\n";
  return;
 }
}



// collect script-, event- and timer-information and write it to file
$scripts = "";
$events = "";
$timers = "";
$allScripts = IPS_GetScripts();
$baseCat = "IP-SYMCON\\". $project;
$subCats = GetAllSubCatsOfScriptCat($allScripts, $baseCat);
foreach($subCats as $cat)
{
 $scripts .= $cat;
 $scriptsOfCat = GetScriptsOfCategory($allScripts, $cat);
 foreach($scriptsOfCat as $script)
 {
  $scripts .= ";". $script;
  $events .= GetVarEventInfo($script);
  $timers .= GetTimEventInfo($script);
 }
 $scripts .= "\r\n";
}

$fh=fopen($projectPath. $project. ".ips.cfg", "w");
if ($scripts != "")
{
 fwrite($fh, "[Scripts]\r\n". $scripts);
}
if ($events != "")
{
 fwrite($fh, "[Events]\r\n". $events);
}
if ($timers != "")
{
 fwrite($fh, "[Timers]\r\n". $timers);
}
fclose($fh);



// collect variable information and write it to file
$variables = "";
$allVariables = IPS_GetVariables();
$baseCat = "IP-SYMCON\\". $project;
$subCats = GetAllSubCatsOfVarCat($allVariables, $baseCat);
foreach($subCats as $cat)
{
 $variables .= $cat;
 $vars = GetVariablesOfCategory($allVariables, $cat);
 foreach($vars as $var)
 {
  $variables .= ";". $var;
  $variables .= ":". IPS_GetVariableType($var);
 }
 $variables .= "\r\n";
}

if ($variables != "")
{
 $fh=fopen($projectPath. $project. ".ips.cfg", "a");
 fwrite($fh, "[Variables]\r\n". $variables);
 fclose($fh);
}



// collect designer forms information and write it to file
$fileList = scandir($projectPath);
$formMask = ".bin";
$mLen = strlen($formMask);
$forms = "";
foreach($fileList as $file)
{
 if (substr($file, -$mLen) == $formMask)
 {
  $forms .= basename($file, $formMask). "\r\n";
 }
}
if ($forms != "")
{
 $fh=fopen($projectPath. $project. ".ips.cfg", "a");
 fwrite($fh, "[Forms]\r\n". $forms);
 fclose($fh);
}



// collect designer image information and write it to file
$imageList = scandir($projectPath);
$imageType = array(".png", ".gif", ".jpg", ".bmp");
$images = "";
foreach($imageList as $image)
{
 foreach($imageType as $type)
 {
  if (substr($image, -4) == $type)
  {
   $images .= basename($image). "\r\n";
   break;
  }
 }
}
if ($images != "")
{
 $fh=fopen($projectPath. $project. ".ips.cfg", "a");
 fwrite($fh, "[Images]\r\n". $images);
 fclose($fh);
}

echo file_get_contents($projectPath. $project. ".ips.cfg");



function GetVarEventInfo($script)
{
 $eventList = IPS_GetScriptEventList($script);
 $s = "";
 foreach($eventList as $arr)
 {
   $s .= $arr['VarName'];
   $s .= ";". $arr['VarType'];
   $s .= ";". $arr['VarEvent']['EventType'];
   $s .= ";". $arr['VarEvent']['EventTrigger'];
   $s .= ";". $arr['VarEvent']['EventScript'];
   $s .= "\r\n";
 }
 return $s;
}

function GetTimEventInfo($script)
{
 return $script. ":". IPS_GetScriptTimer($script). "\r\n";
}

function GetAllSubCatsOfScriptCat($allScripts, $catString)
{
 $subCats = array();
 $sl = strlen($catString);
 foreach($allScripts as $script)
 {
  $cat = LOC_GetLocation_Script($script);
  if (substr($cat, 0, $sl) == $catString)
   $subCats[] = $cat;
 }
 $subCats = array_unique($subCats);
 sort($subCats);
 return $subCats;
}

function GetAllSubCatsOfVarCat($allVariables, $catString)
{
 $subCats = array();
 $sl = strlen($catString);
 foreach($allVariables as $var)
 {
  $cat = LOC_GetLocation_Variable($var['name']);
  if (substr($cat, 0, $sl) == $catString)
   $subCats[] = $cat;
 }
 $subCats = array_unique($subCats);
 sort($subCats);
 return $subCats;
}

function GetScriptsOfCategory($allScripts, $catString)
{
 $catScripts = array();
 $sl = strlen($catString);
 foreach($allScripts as $script)
  if (LOC_GetLocation_Script($script) == $catString)
   $catScripts[] = $script;

 return $catScripts;
}

function GetVariablesOfCategory($allVariables, $catString)
{
 $catVariables = array();
 foreach($allVariables as $variable)
  if (LOC_GetLocation_Variable($variable['name']) == $catString)
   $catVariables[] = $variable['name'];

 return $catVariables;
}
?>
