<?
/*
*******************************
 IP-SYMCON Event Scripting
*******************************
File     : Install.ips.php
Trigger  : 
Interval : 
Author   : HJH
Project  : Installation
Date     : 03.01.07
*/



$project = "AudioPlayer"; // hier den Projektnamen (Name des Ordners) eintragen



// Projekt-Name prfen *********************************************************
$kernelPath = IPS_GetKernelDir();
if ($project == "")
{
 echo "FEHLER:\r\n";
 echo "Kein Projektname angegeben!\r\n\n";
 echo "Beispiel:\r\n";
 echo "\$project = \"Testprojekt\";\r\n\n";
 echo "Installation fehlgeschlagen\r\n";
 return;
}

// Installation-Pfad prfen ****************************************************
$instPath = $kernelPath. "scripts\\Installation\\";
if ($project != "Installation")
{
 if (!file_exists($instPath))
 {
  echo "Pfad   \"". $instPath. "\"   nicht gefunden!\r\n\n";
  echo "Bitte zuerst das Installations-Projekt installieren!\r\n";
  echo "Installation fehlgeschlagen\r\n";
  return;
 }
}

// Projekt-Pfad prfen *********************************************************
$projectPath = $kernelPath. "scripts\\". $project. "\\";
if (!file_exists($projectPath))
{
 echo "Pfad   \"". $projectPath. "\"   nicht gefunden!\r\n\n";
 echo "Installation fehlgeschlagen\r\n";
 return;
}

// Projekt-Info prfen *********************************************************
$infoFile = $projectPath. $project. ".ips.cfg";
if (!file_exists($infoFile))
{
 echo "Projekt-Information   \"". $infoFile. "\"   nicht gefunden!\r\n\n";
 echo "Installation fehlgeschlagen\r\n";
 return;
}

// Projekt-Info lesen **********************************************************
$infoText = file_get_contents($infoFile);
$projectInfo = explode("[", $infoText);

// Projekt-Info in Sektionen gliedern ******************************************
$sections = array();
foreach($projectInfo as $paragraph)
{
 if ($paragraph != "")
 {
  $sections[] = explode("]\r\n", $paragraph);
 }
}

// falls ntig die Grafik-DLL installieren *************************************
$ini = $kernelPath. "php.ini";
if (!file_exists($ini))
{
 echo "Datei \"php.ini\" nicht gefunden". "\r\n";
}
else
{
 $iniFile = file_get_contents($ini);
 $iniLines = explode("\r\n", $iniFile);
 $dir = $kernelPath;
 $dir = rtrim($dir, "\\");
 $dirOK = false;
 $dllOK = false;
 foreach ($iniLines as $iniLine)
 {
  $ext = explode("=", $iniLine);
  if (substr($ext[0], 0, 13) == "extension_dir")
  {
   $dir = trim($ext[1], " \"");
   $dirOK = true;
  }
  else if (substr($ext[0], 0, 9) == "extension")
  {
   if (trim($ext[1], " \"") == "php_gd2.dll")
   {
    $dllOK = true;
    break;
   }
  }
 }
 if (!$dllOK)
 {
echo $dir. "\r\n";
  $src = $instPath. "php_gd2.dll";
  $dst = $dir. "\\php_gd2.dll";
  copy($src, $dst);
  
  $phpini = file_get_contents($ini);
  unlink($ini);
  $fh = fopen($ini, "w");
  if (!$dirOK)
   fwrite($fh, "extension_dir = \"". $dir. "\"\r\n");
  fwrite($fh, "extension = \"php_gd2.dll\"\r\n");
  fwrite($fh, $phpini);
  fclose($fh);
  echo "Die Grafik-DLL \"php_gd2.dll\" wurde installiert.\r\n";
  echo "!!! IP-SYMCON muss neu gestartet werden !!!\r\n";
 }
}

// Sektionen auswerten *********************************************************
foreach($sections as $section)
{
 switch ($section[0])
 {
  case "Scripts":
   RegisterScripts($section[1], $project);
   IPS_Sleep(200);
   break;
  case "Variables":
   RegisterVariables($section[1]);
   break;
  case "Timers":
   RegisterTimers($section[1]);
   break;
  case "TWZs":
//   RegisterTWZs($section[1]);     // noch nicht implementiert
   break;
  case "Events":
   RegisterEvents($section[1]);
   break;
  case "Forms":
   RegisterForms($section[1], $project);
   break;
  case "Images":
   RegisterImages($section[1], $projectPath);
   break;
 }
}

echo "\r\nInstallation abgeschlossen\r\n";
// *****************************************************************************


// **************************** Funktionen *************************************
// alle Scripts registrieren und den zugehrigen Kategorien zuordnen -----------
function RegisterScripts($allScripts, $project)
{
 $scriptsOfCat = explode("\r\n", $allScripts);
 foreach($scriptsOfCat as $scriptList)
 {
  $list = explode(";", $scriptList);
  $cat = $list[0];
  for ($i=1; $i<count($list); $i++)
  {
   if (IPS_ScriptExists($list[$i]))
    IPS_UnregisterScript($list[$i]);
   IPS_RegisterScript($list[$i], $project. "\\". $list[$i]. ".ips.php");
   LOC_SetLocation_Script($list[$i], $cat);
  }
 }
 echo "Scripts wurden registriert\r\n";
}

// alle Variablen anlegen und den zugehrigen Kategorien zuordnen --------------
function RegisterVariables($allVariables)
{
 $varsOfCat = explode("\r\n", $allVariables);
 foreach($varsOfCat as $varList)
 {
  $list = explode(";", $varList);
  $cat = $list[0];
  for ($i=1; $i<count($list); $i++)
  {
   $var = explode(":", $list[$i]);
   if (!IPS_VariableExists($var[0]))
    IPS_CreateVariable($var[0], $var[1]);
   LOC_SetLocation_Variable($var[0], $cat);
  }
 }
 echo "Variablen wurden registriert\r\n";
}

// Variablen-Events registrieren -----------------------------------------------
function RegisterEvents($allEvents)
{
 $varEvents = explode("\r\n", $allEvents);
 foreach($varEvents as $eventInfo)
 {
  $list = explode(";", $eventInfo);
  if (count($list) < 5) continue;
  switch ($list[1])
  {
   case "Float":
    $tv = (float)$list[3];
    break;
   case "Integer":
    $tv = (integer)$list[3];
    break;
   case "Boolean":
    $tv = ($list[3]) ? true : false;
    break;
   default:
    $tv = $list[3];
  }
  IPS_UnregisterVariableEvent($list[0], $list[2], $tv, $list[4]);
  IPS_RegisterVariableEvent($list[0], $list[2], $tv, $list[4]);
 }
 echo "Variablen-Events wurden registriert\r\n";
}

// Timer-Events registrieren ---------------------------------------------------
function RegisterTimers($allTimers)
{
 $timers = explode("\r\n", $allTimers);
 foreach($timers as $timerInfo)
 {
  $array = explode(":", $timerInfo);
  if (count($array)>1)
   IPS_SetScriptTimer($array[0], (integer)$array[1]);
 }
 echo "Timer-Events wurden registriert\r\n";
}

// Designer-Forms registrieren -------------------------------------------------
function RegisterForms($allForms, $project)
{
 $forms = explode("\r\n", $allForms);
 foreach($forms as $form)
 {
  if ($form != "")
  {
   if (DSI_FormExists($form)) DSI_UnregisterForm($form);
   DSI_RegisterForm($form, "..\\scripts\\". $project. "\\". $form. ".bin");
  }
 }
 echo "Designer-Forms wurden registriert\r\n";
}

// Designer-Images registrieren ------------------------------------------------
function RegisterImages($allImages, $path)
{
 $images = explode("\r\n", $allImages);
 foreach($images as $image)
 {
  if ($image != "")
  {
   if (IMGP_ImageExists($image)) IMGP_UnregisterImage($image);
   IMGP_RegisterImage($image, $path. $image);
  }
 }
 echo "Designer-Images wurden registriert\r\n";
}
?>
